jsDAV
=======

jsDAV allows you to easily add WebDAV support to a NodeJS application.
jsDAV is meant to cover the entire standard, and attempts to allow integration using an easy to understand API.

Features
--------

 * Fully WebDAV compliant
 * Supports Windows XP, Windows Vista, Mac OS/X, DavFSv2, Cadaver, Netdrive, Open Office, and probably more
 * Supporting class 1, 2 and 3 Webdav servers
 * Custom property support
 * Locking support

Features in development
-----------------------

 * Pass all Litmus tests
 * CalDAV (to be tested with Evolution, iCal, iPhone and Lightning).

Supported RFC's
---------------

 * [RFC2617]: Basic/Digest auth
 * [RFC2518]: First WebDAV spec
 * [RFC4709]: [DavMount]
 * [RFC5397]: current-user-principal
 * [RFC5689]: Extended MKCOL

RFC's in development
--------------------

 * [RFC3744]: ACL
 * [RFC4791]: CalDAV
 * [RFC4918]: WebDAV revision
 * CalDAV ctag, CalDAV-proxy

[RFC2617]: http://www.ietf.org/rfc/rfc2617.txt
[RFC2518]: http://www.ietf.org/rfc/rfc2518.txt
[RFC3744]: http://www.ietf.org/rfc/rfc3744.txt
[RFC4709]: http://www.ietf.org/rfc/rfc4709.txt
[DavMount]: http://code.google.com/p/sabredav/wiki/DavMount
[RFC4791]: http://www.ietf.org/rfc/rfc4791.txt
[RFC4918]: http://www.ietf.org/rfc/rfc4918.txt
[RFC5397]: http://www.ietf.org/rfc/rfc5689.txt
[RFC5689]: http://www.ietf.org/rfc/rfc5689.txt

See the [wiki](https://github.com/mikedeboer/jsDAV/wiki) for more information!


Amsterdam, 2010. Mike de Boer.